﻿package {
	import flash.display.MovieClip;
	public class Enemy extends Actor {		
		var type:Object = null;
		var velx:Number = 0;
		var vely:Number = 0;
		var target:Pawn = null;
		var nextCheck:Number = 0;
		
		public function Enemy(_x:Number, _y:Number, _type:Object) {
			x = _x;
			y = _y;
			type = _type;
			
			health = type.hp;
			
			AddToContainer(g.enemies);
			AddToLayer(g.layerSorted);
			AddToContainer(g.sorted);
			
			AddEventListener(GEvent.Tick, Tick);
			AddEventListener(GEvent.OnTimeOver, OnTimeOver);
		}
		
		public function Tick(e:GEvent):void {
			var i:int;
			var dirx:Number = 0;
			var diry:Number = 0;
			var lambda:Number;
			var len:Number = 0;
			
			if (target) {
				if (target.IsAlive()) {
					target = null;
				}
				else {
					dirx = target.x - x;
					diry = target.y - y;
					len = Misc.Length(dirx, diry);
					if (len > 0.1) {
						dirx /= len;
						diry /= len;
					}
					velx = Misc.Lerp(velx, dirx * 150, 0.1);
					vely = Misc.Lerp(vely, diry * 150, 0.1);
				}
			}
			else {
				if (nextCheck < g.time) {
					for (i = 0; i < g.pawns.length; i++) {
						var en:Pawn = g.pawns[i];
						if (en.IsAlive()) {
							len = Misc.Length2(en.x - x, en.y - y);
							if (len < 100) {
								target = en;
							}
						}
					}
				}
			}
			
			var dampen:Number = 120;
			if (dirx == 0.0) {
				velx = Misc.Dampen(velx, dampen * T.dt	);
			}
			if (diry == 0.0) {
				vely = Misc.Dampen(vely, dampen * T.dt);
			}
			
			lambda = 150;
			len = Misc.Length(velx, vely);
			if (len > lambda) {
				velx = lambda * velx / len;
				vely = lambda * vely / len;
			}
			
			x += velx * T.dt;
			y += vely * T.dt;
			
			depthValue = y;
		}
		
		public function PointInside(_x:Number, _y:Number):Boolean {
			if (type == T.enemy_red) {
				return Misc.PointInsideCustomAABB(_x, _y, x - 9, y - 35, x + 9, y);
			}
			return false;
		}
		
		public function OnTimeOver(e:GEvent):void {
			Kill();
		}
		
		public function Hurt(_damage:int, _proj:Projectile):void {			
			if (IsAlive()) {
				health -= _damage;
				if (IsAlive()) {
					if (!target) {
						target = _proj.creator;
					}
				}
				// died
				else {
					Kill();
				}
			}
			
			var lambda:Number = 0.85;
			velx += _proj.velx * lambda;
			vely += _proj.vely * lambda;
		}
	}
}



























