﻿package  {
	import flash.display.Bitmap;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	public class Game extends MovieClip {		
		var time:Number = 0;
		var keys:Keys = null;
		
		var sorted:Array = new Array;
		var layerScroll:Sprite = new Sprite;
			var layerGround:Sprite = new Sprite;
			var layerSorted:Sprite = new Sprite;
			var layerTop:Sprite = new Sprite;
			var layerSpirits:Sprite = new Sprite;
		var layerUI:Sprite = new Sprite;
		var layerUI2:Sprite = new Sprite;
		var layerDebug:Sprite = new Sprite;
		
		var state:int = 0;
		var currPawn:Pawn = null;
		
		var globalFrame:int = 0;
		var pawns:Array = null;
			var recordings:Array = null;
		var crops:Array = null;
		var spirits:Array = null;
		var enemies:Array = null;
		var giants:Array = null;
		
		var cauldron:Cauldron = null;
		var resourceHud:ResourceHud = null;
		
		var cursorx:Number = 0;
		var cursory:Number = 0;
		var cursorDown:Boolean = false;
		var cursorDownPrev:Boolean = false;
		var cursorDownFrames:int = 0;
		var cursorDownFirst:Boolean = false;
		
		var showRedSpirits:Boolean = true;
		var showBlueSpirits:Boolean = false;
		var showYellowSpirits:Boolean = false;
		
		var showRedGiant:Boolean = true;
		var showBlueGiant:Boolean = false;
		var showYellowGiant:Boolean = false;
		
		var buyHud:BuyHud = null;
		var resources:Array = new Array;
		var controls:Controls = null;
		var bg:Bitmap = null;
		
		// battle vars
		var nextSort:Number = 0;
		var nextForcedBattleOver:Number = 0;
		
		var numRedSpiritsCreated:int = 0;
		var numBlueSpiritsCreated:int = 0;
		var numYellowSpiritsCreated:int = 0;
		
		var numRedSpiritsKilled:int = 0;
		var numBlueSpiritsKilled:int = 0;
		var numYellowSpiritsKilled:int = 0;
		
		// for dialog
		var currDialog:int = 0;
		var lookAtRedGiant:Boolean = false;
		var lookAtBlueGiant:Boolean = false;
		var lookAtYellowGiant:Boolean = false;
		var showedFirstDialog:Boolean = false;
		var slainRedGiant:Boolean = false;
		
		var numTimesKilled:int = 1;
		
		var redGiantPos:Point = new Point(1203.3 - 400, 257.2 - 300);
		var blueGiantPos:Point = new Point(251.45 - 400, 966.95 - 300);
		var yellowGiantPos:Point = new Point(1289.2 - 400, 1061.35 - 300);
		
		public function Game() {
			Actor.g = this;
			addEventListener(Event.ADDED_TO_STAGE, Added, false, 0, true);
		}
		
		public function Added(e:Event):void {
			gotoAndStop(2);
			
			addChild(layerScroll);
			layerScroll.addChild(layerGround);
			layerScroll.addChild(layerSorted);
			layerScroll.addChild(layerTop);
			layerScroll.addChild(layerSpirits);
			addChild(layerUI);
			addChild(layerUI2);
			addChild(layerDebug);
			
			keys = new Keys(stage);
			removeEventListener(Event.ADDED_TO_STAGE, Added, false);
			addEventListener(Event.ENTER_FRAME, Tick, false, 0, true);
			
			stage.addEventListener(MouseEvent.MOUSE_MOVE, MouseMove, false, 0, true);
			stage.addEventListener(MouseEvent.MOUSE_UP, MouseUp, false, 0, true);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, MouseDown, false, 0, true);
			
			if (T.dev_debugHud)
				new DebugHud();
				
			var i:int;
			for (i = 0; i < 4; i++)
				resources.push(0);
				
			if (T.dev_lastBattle) {
				for (i = 0; i < 4; i++)
					resources[i] = 999;
			}
				
			Flush();
			
			var tempBG:BG = new BG;
			//bg = new Bitmap(Misc.DrawClip(tempBG));
			bg = new Bitmap(Misc.DrawClipCustomDimensions(tempBG, 1600, 1200));
			
			bg.x = -tempBG.marker.x;
			bg.y = -tempBG.marker.y;
			bg.x -= 400;
			bg.y -= 300;
			bg.smoothing = true;
			bg.pixelSnapping = "never";
			
			tempBG = null;
			layerGround.addChild(bg);
			
			//bg.x -= 400;
			//bg.y -= 300;
			
			buyHud = new BuyHud;
			cauldron = new Cauldron();
			resourceHud = new ResourceHud();
			controls = new Controls;
			new MyHud();
			new Crop(250, 325, T.crop_javelin);
			
			//CreatePawnAndGoLive(T.pawn_gatherer);
			//PrompForNextBattle();
			
			//StartNextEvent();
			new Title;
		}
		
		public function GiveResource(_cropType:Object):void {
			resources[_cropType.index]++;
		}
		
		public function LookAt(_x:Number, _y:Number):void {
			layerScroll.x = -(_x - 400);
			layerScroll.y = -(_y - 300);
		}
		
		public function LookTowards(_x:Number, _y:Number, _lambda:Number):void {
			var desired_x:Number = -(_x - 400);
			var desired_y:Number = -(_y - 300);
			layerScroll.x += (desired_x - layerScroll.x) * _lambda;
			layerScroll.y += (desired_y - layerScroll.y) * _lambda;
		}
		
		public function MouseMove(e:MouseEvent):void {
			cursorx = e.stageX;
			cursory = e.stageY;
		}
		
		public function MouseUp(e:MouseEvent):void {
			cursorDown = false;
		}
		
		public function MouseDown(e:MouseEvent):void {
			cursorDown = true;
		}
		
		public function Flush():void {
			var i:int;
			
			pawns = new Array;
			crops = new Array;
			spirits = new Array;
			enemies = new Array;
			giants = new Array;
			
			recordings = new Array;
			for (i = 0; i < T.numPawnTypes; i++) {
				recordings.push(new Array);
			}
		}
		
		public function Cache():void {
			if (currPawn) {
				recordings[currPawn.type.index].push(currPawn.recording);
			}
			dispatchEvent(new GEvent(GEvent.OnTimeOver));
			currPawn = null;
		}
		
		public function GiveFocus():void {
			stage.focus = stage;
		}
		
		public function CreatePawnAndGoLive(_type:Object):void {
			state = T.state_live;
			
			AA.Play(AA.wah);
			LookAt(400, 300);
			
			var i:int;
			var j:int;
			for (i = 0; i < T.numPawnTypes; i++) {
				var recordingsForThisPawnType:Array = recordings[i];
				for (j = 0; j < recordingsForThisPawnType.length; j++) {
					new Pawn(T.pawnTypes[i], recordingsForThisPawnType[j]);
				}
			}
			
			new _HourGlass;
			currPawn = new Pawn(_type, null);
			controls.Show();
			
			//new Enemy(150, 325, T.enemy_red);
			
			numRedSpiritsCreated = 0;
			numBlueSpiritsCreated = 0;
			numYellowSpiritsCreated = 0;
			numRedSpiritsKilled = 0;
			numBlueSpiritsKilled = 0;
			numYellowSpiritsKilled = 0;
			
			if (showRedSpirits || T.dev_lastBattle)
				CreateRedSpirits();
			if (showBlueSpirits || T.dev_lastBattle)
				CreateBlueSpirits();
			if (showYellowSpirits || T.dev_lastBattle)
				CreateYellowSpirits();
			
			if (showRedGiant || T.dev_lastBattle)
				CreateRedGiant();
			if (showBlueGiant || T.dev_lastBattle)
				CreateBlueGiant();
			if (showYellowGiant || T.dev_lastBattle)
				CreateYellowGiant();
				
			nextForcedBattleOver = time + 999999;
			globalFrame = 0;
			GiveFocus();
		}
		
		public function CreateRedGiant():void {
			new Giant(redGiantPos.x, redGiantPos.y, T.giant_red);
		}
		
		public function CreateBlueGiant():void {
			new Giant(blueGiantPos.x, blueGiantPos.y, T.giant_blue);
		}
		
		public function CreateYellowGiant():void {
			new Giant(yellowGiantPos.x, yellowGiantPos.y, T.giant_yellow);
		}
		
		public function CreateRedSpirits():void {
			new Spirit(450, 0.15, 9.5, 0, 1, T.spirit_red);
			new Spirit(400, 0.2, 9, 100, 1, T.spirit_red);
			new Spirit(420, 0.25, 9.5, 200, -1, T.spirit_red);
			//new Spirit(220, 0.25, 4.5, 200, -1, T.spirit_red);
			//new Spirit(320, 0.25, 5.0, 200, -1, T.spirit_red);
		}
		
		public function CreateBlueSpirits():void {
			new Spirit(450, 0.12, 9.2, 0, 1, T.spirit_blue);
			new Spirit(415, 0.18, 10, 100, -1, T.spirit_blue);
			new Spirit(425, 0.17, 9.2, 200, -1, T.spirit_blue);
		}
		
		public function CreateYellowSpirits():void {
			new Spirit(420, 0.13, 9.0, 0, -1, T.spirit_yellow);
			new Spirit(410, 0.177, 9, 100, 1, T.spirit_yellow);
			new Spirit(410, 0.145, 9.0, 200, 1, T.spirit_yellow);
		}
		
		public function EndBattle():void {
			AA.Play(AA.door);
			numTimesKilled++;
			Cache();
			dispatchEvent(new GEvent(GEvent.OnTimeOver));
			state = T.state_waiting;
			controls.Hide();
		}
		
		public function ShouldShowDialiog():Boolean {
			if (T.dev_skipDialog)
				return false;
				
			var redKilled:Boolean = numRedSpiritsCreated > 0 && numRedSpiritsKilled == numRedSpiritsCreated;
			var blueKilled:Boolean = numBlueSpiritsCreated > 0 && numBlueSpiritsKilled == numBlueSpiritsCreated;
			var yellowKilled:Boolean = numYellowSpiritsCreated > 0 && numYellowSpiritsKilled == numYellowSpiritsCreated;
				
			// opening dialog
			if (currDialog == 0 && !showedFirstDialog)
				return true;
			// can build javelin guys
			else if (currDialog == 1 && resources[T.crop_javelin.index] > 0)
				return true;
			// red giant has been slain, send some harvesters
			else if (currDialog == 2 && slainRedGiant)
				return true;
			// have harvested red magic, can create red mages
			else if (currDialog == 3 && resources[T.crop_red.index] > 0) {
				return true;
			}
			// killed all red spirits, need to reveal blue giant
			else if (currDialog == 4 && redKilled) {
				showBlueGiant = true;
				showBlueSpirits = true;
				resourceHud.UpdateInterface();
				return true;
			}
			// killed red and blue spirits, need to reveal yellow giant
			else if (currDialog == 5 && redKilled && blueKilled) {
				showYellowGiant = true;
				showYellowSpirits = true;
				resourceHud.UpdateInterface();
				return true;
			}
			// killed ALL spirits.. game over, show ending.
			else if (currDialog == 6 && redKilled && blueKilled && yellowKilled) {
				return true
			}
			
			return false;
		}
		
		public function ShowDialog():void {
			if (currDialog == 0)
				showedFirstDialog = true;
			new Dialog(currDialog);
			currDialog++;
		}
		
		public function PrompForNextBattle():void {
			resourceHud.GoDown();
			buyHud.Show();
		}
		
		public function StartNextEvent():void {
			if (T.dev_instantGameWin) {
				var dialog:Dialog = new Dialog(0);
				dialog.GameEnding();
				return;
			}
			
			if (ShouldShowDialiog())
				ShowDialog()
			else
				PrompForNextBattle();
		}
		
		public function Tick(e:Event):void {
			var i:int;
			
			keys.Tick();
			time += T.dt;
			AA.Tick(T.dt);
			dispatchEvent(new GEvent(GEvent.Tick));
			
			// -400,-300 | 400, 300
			//trace("" + layerScroll.x + " | " + layerScroll.y);
			
			if (cursorDown)
				cursorDownFrames++;
			else
				cursorDownFrames = 0;
			cursorDownFirst = (cursorDownFrames == 1);
			
			if (state == T.state_live) {
				LookTowards(currPawn.x, currPawn.y, 0.15);
				globalFrame++;
				if (globalFrame >= 300 || nextForcedBattleOver < time) {
					EndBattle();
					StartNextEvent();
				}
			}
			else {
				if (lookAtRedGiant)
					LookTowards(redGiantPos.x, redGiantPos.y, 0.05);
				else if (lookAtBlueGiant)
					LookTowards(blueGiantPos.x, blueGiantPos.y, 0.05);
				else if (lookAtYellowGiant)
					LookTowards(yellowGiantPos.x, yellowGiantPos.y, 0.05);
				else
					LookTowards(400, 300, 0.05);
			}
			
			if (nextSort < time) {
				sorted.sort(SortByDepth);
				while (layerSorted.numChildren > 0)
					layerSorted.removeChildAt(0);
				for (i = 0; i < sorted.length; i++)
					layerSorted.addChild(sorted[i]);
				nextSort = time + 0.1;
			}
			
			layerScroll.x = Misc.Clamp(layerScroll.x, -400, 400);
			layerScroll.y = Misc.Clamp(layerScroll.y, -300, 300);
		}
		
		public function SortByDepth(_a:Actor, _b:Actor):int {
			if (_a.depthValue + _a.depthOffset > _b.depthValue + _b.depthOffset)
				return 1;
			return -1;
		}
		
		public function DoGameOver():void {
			visible = false;
			new GameWin;
			//new DaughterGhost();
		}
	}
}






































