﻿package  {
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	public class Pawn extends Actor {		
		var type:Object = null
		var index:int = 0;
		var recording:Array = null;
		var ghost:Boolean = false;
		var velx:Number = 0;
		var vely:Number = 0;
		var currCropType:Object = null;
		var nextShoot:Number = 0;
		
		public function Pawn(_type:Object, _recording:Array) {
			type = _type;
			recording = _recording;
			
			health = 1;
			
			if (recording) {
				ghost = true;
			}
			else {
				ghost = false;
				recording = new Array;
			}
			arrow.visible = !ghost;
			
			gotoAndStop(type.frame);
			
			x = 400;
			y = 300;
			
			if (type == T.pawn_gatherer)
				something.visible = false;
			
			index = g.pawns.length;
			AddToContainer(g.pawns);
			AddToLayer(g.layerSorted);
			AddToContainer(g.sorted);
			
			AddEventListener(GEvent.Tick, Tick);
			AddEventListener(GEvent.OnTimeOver, OnTimeOver);
		}
		
		public function HandleFrame(_frame:Object):void {
			if (Misc.Sign(velx) != Misc.Sign(_frame.dirx))
				_frame.dirx *= 2;
			if (Misc.Sign(vely) != Misc.Sign(_frame.diry))
				_frame.diry *= 2;
			velx += _frame.dirx * T.dt;
			vely += _frame.diry * T.dt;
			var len:Number = Misc.Length(velx, vely);
			var lambda:Number = type.speed;
			if (len > lambda) {
				velx = lambda * velx / len;
				vely = lambda * vely / len;
			}
			
			// dampen the velocity!
			var dampen:Number = 150;
			if (_frame.dirx == 0.0) {
				velx = Misc.Dampen(velx, dampen * T.dt);
			}
			if (_frame.diry == 0.0) {
				vely = Misc.Dampen(vely, dampen * T.dt);
			}
			
			if (_frame.jav) {
				if (type.proj == T.proj_javelin) {
					AA.PlayRandom(AA.arrThrowJav);
				}
				else {
					AA.Play(AA.mageshoot, 0.66);
				}
				new Projectile(x, y - 25, _frame.jav_velx, _frame.jav_vely, type.proj, this);
			}
			
			if (velx > 0.1)
				scaleX = -1;
			else if (velx < -0.1)
				scaleX = 1;
			
			x += velx * T.dt;
			y += vely * T.dt;
		}
		
		public function Tick(e:GEvent):void {
			var i:int;
			var lambda:Number = 0;
			
			if (!ghost) {
				if (g.state == T.state_live) {
					var acc:Number = 250;
					var frame:Object = new Object;
					frame.dirx = 0;
					frame.diry = 0;
					if (g.keys.keyDown(Keys.key_up) || g.keys.keyDown(Keys.key_w)) {
						frame.diry = -acc;
					}
					if (g.keys.keyDown(Keys.key_down) || g.keys.keyDown(Keys.key_s)) {
						frame.diry = acc;
					}
					if (g.keys.keyDown(Keys.key_left) || g.keys.keyDown(Keys.key_a)) {
						frame.dirx = -acc;
					}
					if (g.keys.keyDown(Keys.key_right) || g.keys.keyDown(Keys.key_d)) {
						frame.dirx = acc;
					}
					
					if (type.proj) {
						if (g.cursorDown && nextShoot < g.time) {
							frame.jav = true;
							frame.jav_velx = (g.cursorx - g.layerScroll.x) - x;
							frame.jav_vely = (g.cursory - g.layerScroll.y) - (y - 25);
							nextShoot = g.time + 0.5;
						}
					}
					
					HandleFrame(frame);
					recording.push(frame);
				}
			}
			else {
				if (g.globalFrame < recording.length)
					HandleFrame(recording[g.globalFrame]);
			}
			
			if (type == T.pawn_gatherer) {
				if (something.visible) {
					lambda = Misc.Length2(g.cauldron.x - x, g.cauldron.y - y);
					if (lambda < 25 * 25) {
						something.visible = false;
						AA.Play(AA.deposit);
						//if (!ghost) {
							g.GiveResource(currCropType);
						//}
					}
				}
				else {
					for (i = 0; i < g.crops.length; i++) {
						var crop:Crop = g.crops[i];
						lambda = Misc.Length2(crop.x - x, crop.y - y);
						if (lambda < crop.rad * crop.rad) {
							AA.Play(AA.pickup);
							something.visible = true;
							currCropType = crop.type;
						}
					}
				}
			}
			
			depthValue = y;
		}
		
		public function Hurt(_amount:Number):void {
			if (IsAlive()) {
				health -= _amount;
				AA.PlayRandom(AA.arrHit);
				if (!IsAlive()) {
					if (!ghost) {
						g.nextForcedBattleOver = g.time + 1;
					}
					Kill();
				}
			}
		}
		
		public function OnTimeOver(e:GEvent):void {
			Kill();
		}
	}
}















































